## calceph 4.0.5

=== CMakeLists.txt ===
#/*-----------------------------------------------------------------*/
#  complete build chain for cmake. 
#
#  Copyright, 2021-2025, CNRS
#   email of the author : Mickael.Gastineau@obspm.fr
#
#/*-----------------------------------------------------------------*/
#/*-----------------------------------------------------------------*/
#/* License  of this file :
#  This file is "triple-licensed", you have to choose one  of the three licenses 
#  below to apply on this file.
#  
#     CeCILL-C
#     	The CeCILL-C license is close to the GNU LGPL.
#     	( http://www.cecill.info/licences/Licence_CeCILL-C_V1-en.html )
#   
#    or CeCILL-B
#        The CeCILL-B license is close to the BSD.
#        (http://www.cecill.info/licences/Licence_CeCILL-B_V1-en.txt)
#  
#    or CeCILL v2.1
#        The CeCILL license is compatible with the GNU GPL.
#        ( http://www.cecill.info/licences/Licence_CeCILL_V2.1-en.html )
#  
# 
# This library is governed by the CeCILL-C, CeCILL-B or the CeCILL license under 
# French law and abiding by the rules of distribution of free software.  
# You can  use, modify and/ or redistribute the software under the terms 
# of the CeCILL-C,CeCILL-B or CeCILL license as circulated by CEA, CNRS and INRIA  
# at the following URL "http://www.cecill.info". 
#
# As a counterpart to the access to the source code and  rights to copy,
# modify and redistribute granted by the license, users are provided only
# with a limited warranty  and the software's author,  the holder of the
# economic rights,  and the successive licensors  have only  limited
# liability. 
#
# In this respect, the user's attention is drawn to the risks associated
# with loading,  using,  modifying and/or developing or reproducing the
# software by the user in light of its specific status of free software,
# that may mean  that it is complicated to manipulate,  and  that  also
# therefore means  that it is reserved for developers  and  experienced
# professionals having in-depth computer knowledge. Users are therefore
# encouraged to load and test the software's suitability as regards their
# requirements in conditions enabling the security of their systems and/or 
# data to be ensured and,  more generally, to use and operate it in the 
# same conditions as regards security. 
#
# The fact that you are presently reading this means that you have had
# knowledge of the CeCILL-C,CeCILL-B or CeCILL license and that you accept its terms.
# */
# /*-----------------------------------------------------------------*/

cmake_minimum_required (VERSION 3.7.0...4.0.2)
project (calceph VERSION 4.0.5 LANGUAGES C)
set(CALCEPH_RELEASE_DATE_FULL "June 2, 2025")

# ABI version number 
# follow  rules : http://www.gnu.org/software/libtool/manual/html_node/Updating-version-info.html
set(CALCEPH_SOVERSION_COMPAT 2)
set(CALCEPH_SOVERSION_FULL ${CALCEPH_SOVERSION_COMPAT}.0.5)


#####################################################################
#  set the main variables
#####################################################################
set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/toolchain")

set(CALCEPH_CONTACT_EMAIL "inpop.imcce@obspm.fr")
set(CALCEPH_MAINTAINER_NAME "Mickaël Gastineau")
set(CALCEPH_URL "https://www.imcce.fr/inpop/calceph/")
set(CALCEPH_VERSION_MAJOR ${PROJECT_VERSION_MAJOR})
set(CALCEPH_VERSION_MINOR ${PROJECT_VERSION_MINOR})
set(CALCEPH_VERSION_PATCH ${PROJECT_VERSION_PATCH})


#####################################################################
#  set the options
#####################################################################
include(CheckLanguage)
check_language(Fortran)
if(CMAKE_Fortran_COMPILER)
    option(ENABLE_FORTRAN "enable fortran API" ON)
else()
    option(ENABLE_FORTRAN "enable fortran API" OFF) 
endif()
    
option(ENABLE_PYTHON "enable python API" OFF)
option(ENABLE_MEX_OCTAVE "enable mex API for Octave" OFF)
option(BUILD_SHARED_LIBS "enable the shared library, otherwise build the static library" OFF)
option(ENABLE_THREAD "enable thread-safe version for high-level API" ON)
option(CALCEPH_INSTALL "enable the generation of install target" ON)
option(ENABLE_DOC "enable the generation and installation of the html documentation" OFF)
option(ENABLE_PDF "enable the generation and installation of the pdf documentation" OFF)
option(ENABLE_SANITIZER "enable the sanitizer options (reserved for developers)" OFF)

#####################################################################
#  enable fortran if required
#####################################################################
set(CALCEPH_FORTRAN_GLOBALCASE "name") 
if (ENABLE_FORTRAN)
    enable_language(Fortran)
    include(FortranCInterface)
    if(${FortranCInterface_GLOBAL_CASE} STREQUAL "UPPER")
        set(CALCEPH_FORTRAN_GLOBALCASE "NAME") 
    endif()
else()
    set(FortranCInterface_GLOBAL__SUFFIX "_")
endif()

#####################################################################
#  enable python if required
#####################################################################
if (ENABLE_PYTHON)
    if (CMAKE_VERSION VERSION_LESS "3.12.0")
        message(ERROR "Python API interface requires CMake 3.12 or later ")
    endif()
    include(FindPython)
    find_package (Python COMPONENTS Interpreter Development REQUIRED)
    file(READ README.pypi SETUPPY_LONG_DESCRIPTION)
    option(ENABLE_PYTHON_TESTS "enable python tests (developers only)" ON)
    if (BUILD_SHARED_LIBS)
        message(STATUS "Python API requires to build the static library")
        set(BUILD_SHARED_LIBS OFF)
    endif()
    set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY "$<1:${CMAKE_ARCHIVE_OUTPUT_DIRECTORY}>")
endif()


#####################################################################
#  enable mex if required
#####################################################################
if (ENABLE_MEX_OCTAVE)
    if (CMAKE_VERSION VERSION_LESS "3.12.0")
        essage(ERROR "Python API interface requires CMake 3.12 or later ")
    endif()
    include(FindOctave)
    find_package(Octave)
    if (BUILD_SHARED_LIBS)
        message(STATUS "MEX API requires to build the static library")
        set(BUILD_SHARED_LIBS OFF)
    endif()
endif()


#####################################################################
#  set the compiler flags 
#####################################################################
IF ("${CMAKE_C_COMPILER_ID}" STREQUAL "Intel")
  MESSAGE(STATUS "Add the option '-fp-model precise' for the Intel compilers")
  string(APPEND CMAKE_C_FLAGS " -fp-model precise ")
ENDIF ()
# Define for the function strod_l
string(APPEND CMAKE_C_FLAGS " -D_GNU_SOURCE=1 ")
# Define to 1 to make fseeko visible on some hosts (e.g. glibc 2.2).
string(APPEND CMAKE_C_FLAGS " -D_LARGEFILE_SOURCE=1 ")
string(APPEND CMAKE_C_FLAGS " -D_LARGE_FILES=1 ")
if(ENABLE_SANITIZER)
  MESSAGE(STATUS "Add the option '-fsanitize=address -g -O0' for the sanitizer")
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fsanitize=address -g -O0")
  set(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -fsanitize=address -g -O0")
endif() 
if (WIN32)
  if (BUILD_SHARED_LIBS)
	  if (MINGW OR MSYS OR CYGWIN)
	  # only for the microsoft compiler
	  elseif (CMAKE_C_COMPILER_ID STREQUAL "MSVC")
		MESSAGE(STATUS "Exporting all symbols on windows")
		set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS TRUE)
	  endif()
  endif()
endif()

#####################################################################
#  detect the headers
#####################################################################
include(CheckIncludeFiles)
if(ENABLE_THREAD)
    find_package(Threads)
endif()
CHECK_INCLUDE_FILES(stdio.h HAVE_STDIO_H )
CHECK_INCLUDE_FILES(stdlib.h HAVE_STDLIB_H )
CHECK_INCLUDE_FILES(stdarg.h STDC_HEADERS)
CHECK_INCLUDE_FILES(limits.h HAVE_LIMITS_H)
CHECK_INCLUDE_FILES(string.h HAVE_STRING_H)
CHECK_INCLUDE_FILES(errno.h HAVE_ERRNO_H)
CHECK_INCLUDE_FILES(math.h HAVE_MATH_H)
CHECK_INCLUDE_FILES(stdbool.h HAVE_STDBOOL_H)
CHECK_INCLUDE_FILES(sys/stat.h HAVE_SYS_STAT_H)
CHECK_INCLUDE_FILES(sys/types.h HAVE_SYS_TYPES_H)
CHECK_INCLUDE_FILES(unistd.h HAVE_UNISTD_H)
CHECK_INCLUDE_FILES(time.h HAVE_TIME_H)
CHECK_INCLUDE_FILES(sys/mman.h HAVE_SYS_MMAN_H)
CHECK_INCLUDE_FILES(sys/resource.h HAVE_SYS_RESOURCE_H)
CHECK_INCLUDE_FILES(xlocale.h HAVE_XLOCALE_H)
CHECK_INCLUDE_FILES(locale.h HAVE_LOCALE_H)
if (CMAKE_USE_PTHREADS_INIT)
    CHECK_INCLUDE_FILES(pthread.h HAVE_PTHREAD_H)
    set(HAVE_PTHREAD 1)
    set(FORTRAN_HAVE_PTHREAD 1)
else()
    set(FORTRAN_HAVE_PTHREAD 0)
endif()
if (WIN32)
    set(HAVE_WINDOWS_H 1)
endif()

#####################################################################
#  detect the types
#####################################################################
include(CheckCSourceCompiles)
CHECK_C_SOURCE_COMPILES(
    "
    #include <stdbool.h>
    int main(int argc, char** argv) { (void)argc; (void)argv; bool b = true; return b!=false; }
    " 
    HAVE_BOOL
)

#####################################################################
#  detect the attributes
#####################################################################
CHECK_C_SOURCE_COMPILES(
    "
    #include <math.h>
    int main(int argc __attribute__((__unused__)) , char** argv __attribute__((__unused__))) {  return 0; }
    "  
    HAVE_VAR_ATTRIBUTE_UNUSED
)

#####################################################################
#  detect the libraries
#####################################################################
# the math library is not required with microsoft compilers or MinGW
if (WIN32)
 set(LIBM_LIBRARIES "")
else(WIN32)
    if (MINGW)
     set(LIBM_LIBRARIES "")
    else(MINGW)
     find_library(LIBM_LIBRARIES m)
    endif(MINGW)
endif(WIN32)

#####################################################################
#  detect the functions
#####################################################################
include (CheckFunctionExists)
CHECK_C_SOURCE_COMPILES(
    "
    #include <math.h>
    int main(int argc, char** argv) { (void)argc; (void)argv; return rint(1.0E0); }
    "  
    HAVE_RINT
)

CHECK_FUNCTION_EXISTS(snprintf HAVE_SNPRINTF)
CHECK_FUNCTION_EXISTS(vasprintf HAVE_VASPRINTF)
CHECK_FUNCTION_EXISTS(_vscprintf HAVE__VSCPRINTF)
CHECK_FUNCTION_EXISTS(vsnprintf HAVE_VSNPRINTF)
CHECK_FUNCTION_EXISTS(strncmp HAVE_STRNCMP)
CHECK_FUNCTION_EXISTS(strcasecmp HAVE_STRCASECMP)
CHECK_FUNCTION_EXISTS(_stricmp HAVE__STRICMP)
CHECK_FUNCTION_EXISTS(strtod_l HAVE_STRTOD_L)
CHECK_FUNCTION_EXISTS(_strtod_l HAVE__STRTOD_L)
CHECK_FUNCTION_EXISTS(newlocale HAVE_NEWLOCALE)
CHECK_FUNCTION_EXISTS(freelocale HAVE_FREELOCALE)
CHECK_FUNCTION_EXISTS(setlocale HAVE_SETLOCALE)
CHECK_FUNCTION_EXISTS(mmap HAVE_MMAP)
CHECK_FUNCTION_EXISTS(fseeko HAVE_FSEEKO)
CHECK_FUNCTION_EXISTS(_fseeki64 HAVE__FSEEKI64)
CHECK_FUNCTION_EXISTS(strerror_r HAVE_STRERROR_R)
CHECK_FUNCTION_EXISTS(strerror_s HAVE_STRERROR_S)

add_definitions(-DHAVE_CONFIG_H=1)


#####################################################################
#  set the core C functions of the library
#####################################################################
set(CALCEPH_C_SOURCE
    calceph.c			calcephspkinterpolhermite.c
    calcephast.c			calcephspkinterpollagrange.c
    calcephbinpckio.c		calcephspkio.c
    calcephchebyshev.c		calcephspkseg1.c
    calcephfileversion.c		calcephspkseg12.c
    calcephinpopfileversion.c	calcephspkseg13.c
    calcephinpopio.c		calcephspkseg17.c
    calcephinpoporientrecord.c	calcephspkseg18.c
    calcephinpoppositionrecord.c	calcephspkseg2.c
    calcephinpoptime.c		calcephspkseg21.c
    calcephio.c			calcephspkseg5.c
    calcephlink.c			calcephstatetype.c
    calcephorientrecord.c		calcephtime.c
    calcephpam.c			calcephtxtfkio.c
    calcephpositionrecord.c		calcephtxtmkio.c
    calcephspice.c			calcephtxtpckio.c
    calcephspicefileversion.c	calcephtxtpckorient.c
    calcephspiceorientrecord.c	calcephversion.c
    calcephspicepositionrecord.c	interfaces_C_F90.c
    calcephspicetime.c		util.c
    calcephspkseg14.c  calcephidbyname.c
    calcephspkseg19.c
)

if (ENABLE_PYTHON)

=== doc/CMakeLists.txt ===
#/*-----------------------------------------------------------------*/
#  build the documentation
#
#  Copyright, 2023-2025, CNRS
#   email of the author : Mickael.Gastineau@obspm.fr
#
#/*-----------------------------------------------------------------*/
#/*-----------------------------------------------------------------*/
#/* License  of this file :
#  This file is "triple-licensed", you have to choose one  of the three licenses 
#  below to apply on this file.
#  
#     CeCILL-C
#     	The CeCILL-C license is close to the GNU LGPL.
#     	( http://www.cecill.info/licences/Licence_CeCILL-C_V1-en.html )
#   
#    or CeCILL-B
#        The CeCILL-B license is close to the BSD.
#        (http://www.cecill.info/licences/Licence_CeCILL-B_V1-en.txt)
#  
#    or CeCILL v2.1
#        The CeCILL license is compatible with the GNU GPL.
#        ( http://www.cecill.info/licences/Licence_CeCILL_V2.1-en.html )
#  
# 
# This library is governed by the CeCILL-C, CeCILL-B or the CeCILL license under 
# French law and abiding by the rules of distribution of free software.  
# You can  use, modify and/ or redistribute the software under the terms 
# of the CeCILL-C,CeCILL-B or CeCILL license as circulated by CEA, CNRS and INRIA  
# at the following URL "http://www.cecill.info". 
#
# As a counterpart to the access to the source code and  rights to copy,
# modify and redistribute granted by the license, users are provided only
# with a limited warranty  and the software's author,  the holder of the
# economic rights,  and the successive licensors  have only  limited
# liability. 
#
# In this respect, the user's attention is drawn to the risks associated
# with loading,  using,  modifying and/or developing or reproducing the
# software by the user in light of its specific status of free software,
# that may mean  that it is complicated to manipulate,  and  that  also
# therefore means  that it is reserved for developers  and  experienced
# professionals having in-depth computer knowledge. Users are therefore
# encouraged to load and test the software's suitability as regards their
# requirements in conditions enabling the security of their systems and/or 
# data to be ensured and,  more generally, to use and operate it in the 
# same conditions as regards security. 
#
# The fact that you are presently reading this means that you have had
# knowledge of the CeCILL-C,CeCILL-B or CeCILL license and that you accept its terms.
# */
# /*-----------------------------------------------------------------*/
set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/toolchain")

configure_file(source/confcommon.py.in source/confcommon.py)

find_package(SphinxDoc)
if (ENABLE_PDF)
    find_package(LATEX COMPONENTS PDFLATEX)
endif()

if(NOT TARGET doc)
    add_custom_target(doc)
endif()

# function to build the documentation for one language
function(builddoc languagesource languagecommon languagename)
    configure_file(${languagesource}/conf.py.in ${languagesource}/conf.py)

        # build the html documentation for one language
    if (ENABLE_DOC)
    add_custom_target(doc_${languagename}_html
        ${SPHINXDOC_EXECUTABLE} -b html -d "${CMAKE_CURRENT_BINARY_DIR}/sphinxdoctrees_html_${languagename}" -c "${CMAKE_CURRENT_BINARY_DIR}/${languagesource}/" ${languagecommon}  "${CMAKE_CURRENT_BINARY_DIR}/html/${languagename}"
        WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
        COMMENT "build the HTML documentation for the language ${languagename}")
    add_dependencies(doc doc_${languagename}_html)  
    
    install(DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/html/${languagename}" DESTINATION "${CMAKE_INSTALL_DATADIR}/doc/calceph/html/" )

    endif(ENABLE_DOC)
    
    # build the pdf documentation for one language
    if (ENABLE_PDF)
        if(LATEX_PDFLATEX_FOUND)
            set(latexdir "${CMAKE_CURRENT_BINARY_DIR}/latex/${languagename}")
            add_custom_target(doc_${languagename}_pdf
                ${SPHINXDOC_EXECUTABLE} -b latex -d "${CMAKE_CURRENT_BINARY_DIR}/sphinxdoctrees_pdf_${languagename}" -c "${CMAKE_CURRENT_BINARY_DIR}/${languagesource}/" ${languagecommon}  ${latexdir}
                WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
                COMMENT "build the pdf documentation for the language ${languagename}")

                # get all xrefs using three compilation
            add_custom_command(TARGET doc_${languagename}_pdf POST_BUILD
                COMMAND "${PDFLATEX_COMPILER}" "calceph.tex"
                COMMAND "${PDFLATEX_COMPILER}" "calceph.tex"
                COMMAND "${PDFLATEX_COMPILER}" "calceph.tex"
                COMMAND ${CMAKE_COMMAND} -E copy "${latexdir}/calceph.pdf"  "${CMAKE_CURRENT_BINARY_DIR}/calceph_${languagename}.pdf"
                WORKING_DIRECTORY "${latexdir}")

                add_dependencies(doc doc_${languagename}_pdf)  

                install(FILES "${CMAKE_CURRENT_BINARY_DIR}/calceph_${languagename}.pdf" DESTINATION "${CMAKE_INSTALL_DATADIR}/doc/calceph/")

        endif() 
    endif()
endfunction()



builddoc(source_c source c )
builddoc(source_f2003 source fortran2003 )
builddoc(source_f9x source fortran9x )
builddoc(source_python source python )
builddoc(source_mex source mex )

=== tests/CMakeLists.txt ===
#/*-----------------------------------------------------------------*/
#/*! 
#  \file CMakeLists.txt
#  \brief build chain of the tests for cmake. 
#  \author  M. Gastineau 
#           Astronomie et Systemes Dynamiques, LTE, CNRS, Observatoire de Paris. 
#
#   Copyright, 2021-2025, CNRS
#   email of the author : Mickael.Gastineau@obspm.fr
#  
#*/
#/*-----------------------------------------------------------------*/
#
#/*-----------------------------------------------------------------*/
#/* License  of this file :
#  This file is "triple-licensed", you have to choose one  of the three licenses 
#  below to apply on this file.
#  
#     CeCILL-C
#     	The CeCILL-C license is close to the GNU LGPL.
#     	( http://www.cecill.info/licences/Licence_CeCILL-C_V1-en.html )
#   
#  or CeCILL-B
#        The CeCILL-B license is close to the BSD.
#        (http://www.cecill.info/licences/Licence_CeCILL-B_V1-en.txt)
#  
#  or CeCILL v2.1
#       The CeCILL license is compatible with the GNU GPL.
#       ( http://www.cecill.info/licences/Licence_CeCILL_V2.1-en.html )
#  
# 
# This library is governed by the CeCILL-C, CeCILL-B or the CeCILL license under 
# French law and abiding by the rules of distribution of free software.  
# You can  use, modify and/ or redistribute the software under the terms 
# of the CeCILL-C,CeCILL-B or CeCILL license as circulated by CEA, CNRS and INRIA  
# at the following URL "http://www.cecill.info". 
#
# As a counterpart to the access to the source code and  rights to copy,
# modify and redistribute granted by the license, users are provided only
# with a limited warranty  and the software's author,  the holder of the
# economic rights,  and the successive licensors  have only  limited
# liability. 
#
# In this respect, the user's attention is drawn to the risks associated
# with loading,  using,  modifying and/or developing or reproducing the
# software by the user in light of its specific status of free software,
# that may mean  that it is complicated to manipulate,  and  that  also
# therefore means  that it is reserved for developers  and  experienced
# professionals having in-depth computer knowledge. Users are therefore
# encouraged to load and test the software's suitability as regards their
# requirements in conditions enabling the security of their systems and/or 
# data to be ensured and,  more generally, to use and operate it in the 
# same conditions as regards security. 
#
# The fact that you are presently reading this means that you have had
# knowledge of the CeCILL-C,CeCILL-B or CeCILL license and that you accept its terms.
# */
# /*-----------------------------------------------------------------*/



include_directories("${CMAKE_CURRENT_SOURCE_DIR}/../src")
include_directories(${CMAKE_CURRENT_BINARY_DIR})

add_library(calcephtest openfiles.c numericalderivative.c)
target_link_libraries (calcephtest calceph ${LIBM_LIBRARIES})

file(REMOVE "${CMAKE_CURRENT_BINARY_DIR}/example1_tests_23_derivative.dat")
set(top_srcdir "${CMAKE_CURRENT_SOURCE_DIR}")
string(REPLACE "/" "/\"\n     & //\"" FORTRAN_TESTS_DIR "${CMAKE_CURRENT_SOURCE_DIR}")
CONFIGURE_FILE(fopenfiles.h.in fopenfiles.h )
CONFIGURE_FILE(fthreadsafe.h.in fthreadsafe.h )

#####################################################################
# common options for test files
function(buildtestscommon execname)
  add_test( ${execname}  ${execname} )
  set_tests_properties(${execname} PROPERTIES ENVIRONMENT "srcdir=${CMAKE_CURRENT_SOURCE_DIR}")  
  if (WIN32)  
	set_property(TEST ${execname} PROPERTY ENVIRONMENT_MODIFICATION "PATH=path_list_append:${CMAKE_BINARY_DIR}/src")
  endif()
endfunction(buildtestscommon)

#####################################################################
# single C test file
function(buildtestscsimple execname sourcename)
  add_executable (${execname} ${sourcename})
  target_link_libraries (${execname} PRIVATE calcephtest calceph ${LIBM_LIBRARIES})
  buildtestscommon( ${execname} )
 endfunction(buildtestscsimple)

set (LIST_TEST_C_SIMPLE cversion csopenfail cmopenfail  csopen cmopen cmgetconstant csgetconstant cscheck cmcheck 
                 csgetconstantindex cmgetconstantindex
                 cmgetconstanttxtpck cmgetconstantindextxtpck cmcheckspk cmcomputeunitfail 
                 cmcomputeunit cmcomputeunit_naifid cmcheckspktt cmorientunitfail matrixfail 
                 tfmatrix cmcomputeunitfail2 checktpc_10086     
                 cmorientunitfailspk cmcomputeorder01 cmcomputeorder23 checkcst_11015 cmorientunitfail_11025 
                 crotangmomunitfail crotangmomunitfail2 crotangmomunit crotangmomorder0 crotangmomorder123 
                 cmtimescale cstimescale cmtimespan cstimespan cgetpositionrecordindex cgetorientrecordindex 
                 cmorientunitfail_11612 cmgetconstant_11627  cmopenfail_11628 cmgetconstantvd 
                 cmgetconstantvs csfileversionstr cmparallelcheck cmpolerade checktpc_12301 
                 cmaxsupportedderivative checktpc_12730 checktpc_incremental cmcomputeunit_framerelative
                 cmgetidbyname cmgetnamebyidss checktf_7
)
                 
foreach (C_SIMPLE IN LISTS LIST_TEST_C_SIMPLE)
    buildtestscsimple(${C_SIMPLE} ${C_SIMPLE}.c)
endforeach()



#####################################################################
# C test file with computehermite
function(buildtestschermite execname sourcename)
  add_executable (${execname} ${sourcename} cmcomputeunit_hermite.c)
  target_link_libraries (${execname} calcephtest calceph ${LIBM_LIBRARIES})
  buildtestscommon( ${execname} )
endfunction(buildtestschermite)

set (LIST_TEST_C_HERMITE cmcomputeunit_seg1 cmcomputeunit_seg8
                 cmcomputeunit_seg9 cmcomputeunit_seg12  cmcomputeunit_seg13 
                 cmcomputeunit_seg14 cmcomputeunit_seg21
                 cmcomputeunit_frame
)
                 
foreach (C_HERMITE IN LISTS LIST_TEST_C_HERMITE)
    buildtestschermite(${C_HERMITE} ${C_HERMITE}.c)
endforeach()

#####################################################################
# Fortran test file
if (ENABLE_FORTRAN)

    function(buildtestsfsimple execname sourcename)
      add_executable (${execname} ${sourcename})
      target_link_libraries (${execname} calcephtest calceph ${LIBM_LIBRARIES})
	  buildtestscommon( ${execname} )
    endfunction(buildtestsfsimple)

    set (LIST_TEST_FORTRAN_SIMPLE f2003sopenfail f2003mopenfail f2003sopen  f2003mopen f2003sgetconstant 
                     f2003mgetconstant f2003mcheck f2003sgetconstantindex f2003mgetconstantindex 
                     f2003mcomputeunit f2003mcomputeunit_naifid f2003version 
                     f2003mcomputeorder f2003rotangmomunit f2003rotangmomorder 
                     f2003mtimescale f2003mtimespan f2003stimescale f2003stimespan  
                     f2003getpositionrecordindex f2003getorientrecordindex 
                     f2003mgetconstantvd f2003mgetconstantvs f2003mfileversion f2003sfileversion 
                     f2003misthreadsafe f2003maxsupportedderivativeorder 
                     f2003mgetidbyname f2003mgetnamebyidss
                     f77sopenfail f77mopenfail f77sopen  f77mopen f77sgetconstant 
                     f77mgetconstant f77mcheck f77sgetconstantindex f77mgetconstantindex 
                     f77mcomputeunit  f77mcomputeunit_naifid f77version 
                     f77mcomputeorder f77rotangmomunit f77rotangmomorder 
                     f77mtimescale f77mtimespan f77stimescale f77stimespan  
                     f77getpositionrecordindex f77getorientrecordindex 
                     f77mgetconstantvd f77mgetconstantvs f77mfileversion f77sfileversion 
                     f77misthreadsafe f77maxsupportedderivativeorder
                     f77mgetidbyname f77mgetnamebyidss
    )
                 
    foreach( FORTRAN_SIMPLE IN LISTS LIST_TEST_FORTRAN_SIMPLE)
        buildtestsfsimple(${FORTRAN_SIMPLE} ${FORTRAN_SIMPLE}.f)
    endforeach()

endif()

set_property(TARGET cmcomputeorder23
        APPEND
        PROPERTY ADDITIONAL_MAKE_CLEAN_FILES example1_tests_23_derivative.dat
) 


#####################################################################
# C test file with extra files
function(buildtestsextra execname sourcename)
  add_executable (${execname} ${sourcename} cmcomputeunit_hermite.c)
  target_link_libraries (${execname} calcephtest calceph ${LIBM_LIBRARIES})
endfunction(buildtestsextra)

set (LIST_TEST_C_EXTRA  cmcomputeunit_seg5  cmcomputeunit_seg17 
                 cmcomputeunit_seg18 cmcomputeunit_seg19 cmcomputeunit_seg20
)
                 
foreach (C_EXTRA IN LISTS LIST_TEST_C_EXTRA)
    buildtestsextra(${C_EXTRA} ${C_EXTRA}.c)
endforeach()

=== mexapi/tests/CMakeLists.txt ===
#/*-----------------------------------------------------------------*/
#/*! 
#  \file CMakeLists.txt
#  \brief tests of the mex api for cmake. 
#  \author  M. Gastineau 
#           Astronomie et Systemes Dynamiques, IMCCE, CNRS, Observatoire de Paris. 
#
#   Copyright, 2023-2024, CNRS
#   email of the author : Mickael.Gastineau@obspm.fr
#  
#*/
#/*-----------------------------------------------------------------*/
#
#/*-----------------------------------------------------------------*/
#/* License  of this file :
#  This file is "triple-licensed", you have to choose one  of the three licenses 
#  below to apply on this file.
#  
#     CeCILL-C
#     	The CeCILL-C license is close to the GNU LGPL.
#     	( http://www.cecill.info/licences/Licence_CeCILL-C_V1-en.html )
#   
#  or CeCILL-B
#        The CeCILL-B license is close to the BSD.
#        (http://www.cecill.info/licences/Licence_CeCILL-B_V1-en.txt)
#  
#  or CeCILL v2.1
#       The CeCILL license is compatible with the GNU GPL.
#       ( http://www.cecill.info/licences/Licence_CeCILL_V2.1-en.html )
#  
# 
# This library is governed by the CeCILL-C, CeCILL-B or the CeCILL license under 
# French law and abiding by the rules of distribution of free software.  
# You can  use, modify and/ or redistribute the software under the terms 
# of the CeCILL-C,CeCILL-B or CeCILL license as circulated by CEA, CNRS and INRIA  
# at the following URL "http://www.cecill.info". 
#
# As a counterpart to the access to the source code and  rights to copy,
# modify and redistribute granted by the license, users are provided only
# with a limited warranty  and the software's author,  the holder of the
# economic rights,  and the successive licensors  have only  limited
# liability. 
#
# In this respect, the user's attention is drawn to the risks associated
# with loading,  using,  modifying and/or developing or reproducing the
# software by the user in light of its specific status of free software,
# that may mean  that it is complicated to manipulate,  and  that  also
# therefore means  that it is reserved for developers  and  experienced
# professionals having in-depth computer knowledge. Users are therefore
# encouraged to load and test the software's suitability as regards their
# requirements in conditions enabling the security of their systems and/or 
# data to be ensured and,  more generally, to use and operate it in the 
# same conditions as regards security. 
#
# The fact that you are presently reading this means that you have had
# knowledge of the CeCILL-C,CeCILL-B or CeCILL license and that you accept its terms.
# */
# /*-----------------------------------------------------------------*/


set(CALCEPHMEXSHAREDPATH "${PROJECT_BINARY_DIR}/src")

configure_file(openfilesbinary.m.in openfilesbinary.m)

#####################################################################
# single mex test file
function(buildtestsoctave  sourcename)
  set(TEST_FILE_OCTAVE "${sourcename}")
  configure_file(testoctave.m.in ${sourcename}.m)
  add_test(NAME ${sourcename}_m COMMAND "${OCTAVE_EXECUTABLE}" "-W" "${CMAKE_CURRENT_BINARY_DIR}/${sourcename}.m" WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})
  set_tests_properties(${sourcename}_m PROPERTIES RUN_SERIAL True) 
endfunction(buildtestsoctave)

set (LIST_TEST_OCTAVE_SIMPLE  mgetconstant           mgetconstantindex  
  getorientrecordindex          morientunitfail      tgetversionstr 
  getpositionrecordindex        topen1               mcheck                                    
  mcomputeorder01              topen2                topen3 
  mcomputeorder23                                    topenfail 
  mcomputeunit                  rotangmomorder0               ttimescale 
  mcomputeunitfail              rotangmomunit                 ttimespan 
  mcomputeunitnaifid            terror                        mcomputearray 
  mcomputeunitarray             mcomputeorderarray            morientunitarray 
  morientorderarray             mrotangmomunitarray           mrotangmomorder0array 
  mgetconstantvd               mgetconstantvs                 tfileversion 
  tisthreadsafe                maxsupportedderivativeorder    mgetidbyname
  mgetnamebyidss
)
 
if (Octave_FOUND)
  foreach (OCTAVE_SIMPLE IN LISTS LIST_TEST_OCTAVE_SIMPLE)
      buildtestsoctave(${OCTAVE_SIMPLE})
  endforeach()
  set_tests_properties(mcomputeorder23_m PROPERTIES DEPENDS cmcomputeorder23) 
endif()

=== pythonapi/tests/CMakeLists.txt ===
#/*-----------------------------------------------------------------*/
#/*! 
#  \file CMakeLists.txt
#  \brief build chain of the tests of the python api for cmake. 
#  \author  M. Gastineau 
#           Astronomie et Systemes Dynamiques, IMCCE, CNRS, Observatoire de Paris. 
#
#   Copyright, 2021-2024, CNRS
#   email of the author : Mickael.Gastineau@obspm.fr
#  
#*/
#/*-----------------------------------------------------------------*/
#
#/*-----------------------------------------------------------------*/
#/* License  of this file :
#  This file is "triple-licensed", you have to choose one  of the three licenses 
#  below to apply on this file.
#  
#     CeCILL-C
#     	The CeCILL-C license is close to the GNU LGPL.
#     	( http://www.cecill.info/licences/Licence_CeCILL-C_V1-en.html )
#   
#  or CeCILL-B
#        The CeCILL-B license is close to the BSD.
#        (http://www.cecill.info/licences/Licence_CeCILL-B_V1-en.txt)
#  
#  or CeCILL v2.1
#       The CeCILL license is compatible with the GNU GPL.
#       ( http://www.cecill.info/licences/Licence_CeCILL_V2.1-en.html )
#  
# 
# This library is governed by the CeCILL-C, CeCILL-B or the CeCILL license under 
# French law and abiding by the rules of distribution of free software.  
# You can  use, modify and/ or redistribute the software under the terms 
# of the CeCILL-C,CeCILL-B or CeCILL license as circulated by CEA, CNRS and INRIA  
# at the following URL "http://www.cecill.info". 
#
# As a counterpart to the access to the source code and  rights to copy,
# modify and redistribute granted by the license, users are provided only
# with a limited warranty  and the software's author,  the holder of the
# economic rights,  and the successive licensors  have only  limited
# liability. 
#
# In this respect, the user's attention is drawn to the risks associated
# with loading,  using,  modifying and/or developing or reproducing the
# software by the user in light of its specific status of free software,
# that may mean  that it is complicated to manipulate,  and  that  also
# therefore means  that it is reserved for developers  and  experienced
# professionals having in-depth computer knowledge. Users are therefore
# encouraged to load and test the software's suitability as regards their
# requirements in conditions enabling the security of their systems and/or 
# data to be ensured and,  more generally, to use and operate it in the 
# same conditions as regards security. 
#
# The fact that you are presently reading this means that you have had
# knowledge of the CeCILL-C,CeCILL-B or CeCILL license and that you accept its terms.
# */
# /*-----------------------------------------------------------------*/

#####################################################################
# single python test file
function(buildtestspythonsimple execname sourcename)
  set(CALCEPHPYSHAREDPATH "${PROJECT_BINARY_DIR}/pythonapi/src")
  add_test(NAME ${execname}_py COMMAND "${Python_EXECUTABLE}" "${CMAKE_CURRENT_SOURCE_DIR}/${sourcename}" )
  set_tests_properties(${execname}_py PROPERTIES ENVIRONMENT "PYTHONPATH=${CALCEPHPYSHAREDPATH}:${PYTHONPATH};srcdir=${CMAKE_CURRENT_SOURCE_DIR}")
  endfunction(buildtestspythonsimple)

set (LIST_TEST_PYTHON_SIMPLE 
     mopen mopenfail mgetconstant mgetconstantindex mcheck 
     mcomputeunitfail mcomputeunit mcomputeunitnaifid morientunitfail 
     getversionstr mcomputeorder01 mcomputeorder23 error 
     rotangmomunit rotangmomorder0 timescale timespan 
     getpositionrecordindex getorientrecordindex mgetconstantvd 
     mgetconstantvs fileversion mcomputearrayfail mcomputearray 
     mcomputeunitarray mcomputeorderarray morientunitarray morientorderarray 
     maxsupportedderivativeorder mgetidbyname mgetnamebyidss
)
                 
foreach (PYTHON_SIMPLE IN LISTS LIST_TEST_PYTHON_SIMPLE)
    buildtestspythonsimple(${PYTHON_SIMPLE} ${PYTHON_SIMPLE}.py)
endforeach()
set_tests_properties(mcomputeorder23_py PROPERTIES DEPENDS cmcomputeorder23)

=== debian/changelog ===
calceph (4.0.5-2) experimental; urgency=medium

  * Added autopkgtest integration tests

 -- Attila Kovacs <attipaci@gmail.com>  Tue, 22 Jul 2025 14:36:04 +0200

calceph (4.0.5-1) experimental; urgency=medium

  * Update to upstream 4.0.5 
  * Update debian/libcalceph2.symbols

 -- Attila Kovacs <attipaci@gmail.com>  Wed, 04 Jun 2025 14:43:06 +0200

=== debian/control ===
Source: calceph
Maintainer: Debian Astro Team <debian-astro-maintainers@lists.alioth.debian.org>
Uploaders: Attila Kovacs <attila.kovacs@cfa.harvard.edu>
Section: devel
Priority: optional
Build-Depends: debhelper-compat (= 13), cmake, gfortran
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/debian-astro-team/calceph
Vcs-Git: https://salsa.debian.org/debian-astro-team/calceph.git
Homepage: https://www.imcce.fr/inpop/calceph
Rules-Requires-Root: no
Testsuite: autopkgtest

Package: calceph
Architecture: any
Section: science
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Planetary ephemeris data access tools
 This package provides the command-line tools provided by the CALCEPH library.
 The CALCEPH Library is designed to access planetary ephemeris data, such
 INPOPxx and JPL DExxx ephemeris files, and the SPICE kernel (SPK) files.

Package: libcalceph2
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Shared library for planetary ephemeris data access
 The CALCEPH Library is designed to access the binary planetary ephemeris
 files, such INPOPxx and JPL DExxx ephemeris files, and the SPICE kernel
 (SPK) files.

Package: libcalceph-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libcalceph2 (= ${binary:Version})
Description: C development files for planetary ephemeris data access
 This sub-package provides C headers and non-versioned shared library symbolic
 links for the CALCEPH library.

Package: libcalceph-fortran-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libcalceph2 (= ${binary:Version})
Description: Fortran bindings for the CALCEPH library
 This sub-package provides bindings for Fotran development that wants to use
 CALCEPH.

=== debian/tests/control ===
Tests: test-functionality
Depends: @, build-essential, shunit2
Restrictions: allow-stderr
